﻿(function($) {
    // using this pattern helps keeping your privates private
    criteria = {};
    criteria.init = function(e, gadgetContext) {

        var gadgetInstance = gadgetContext.instance;
        var fieldrouteValues = { action: "Conditions" };
        var fielddefactionUrl = gadgetInstance.getActionPath(fieldrouteValues);
        var fieldDefinitions;
        $.getJSON(fielddefactionUrl, null, function(data) {
            fieldDefinitions = data;
        });

        var valuetypeRouteValues = { action: "Valuetypes" };
        var valuetypeActionUrl = gadgetInstance.getActionPath(valuetypeRouteValues);
        var valuetypes;
        $.getJSON(valuetypeActionUrl, null, function(data) {
            valuetypes = data;
        });


        var CommonPropertyRouteValues = { action: "CommonProperties" };
        var CommonPropetyActionUrl = gadgetInstance.getActionPath(CommonPropertyRouteValues);
        var CommonPropertyNames;
        $.getJSON(CommonPropetyActionUrl, null, function(data) {
            CommonPropertyNames = data;
        });

        

        var addcrit = function(e) {

            // Determine the index of the next row to insert
            var index = $("tr[id^=queryRow]").size();
            // Create DOM element for table row
            var oTr = $(document.createElement("tr")).attr("id", "queryRow" + index);
            // Create DOM element for value textbox

            var oValueTextBox = $(document.createElement("input")).attr("name", "query[" + index + "].Value").attr("id", "Value" + index).attr("type", "text");

            var oIsRequiredCheckbox = $(document.createElement("input")).attr("name", "query[" + index + "].Required").attr("id", "Required" + index).attr("type", "checkbox");
            var oIsNullCheckbox = $(document.createElement("input")).attr("name", "query[" + index + "].IsNull").attr("id", "IsNull" + index).attr("type", "checkbox");

            var oCustomPropertyNameTextBox = $(document.createElement("input")).attr("name", "query[" + index + "].Name").attr("id", "Name" + index).attr("type", "text");


            // Create DOM element for Remove button to delete the row from the table
            var oButtonRemove = $(document.createElement("input")).attr("type", "button").attr("value", "Remove criteria").attr("id", "Remove" + index).click(function() {
                removeRow(index);
            });
            // Create <td> elements
            oTr.append($(document.createElement("td")).append(createcondition(index, fieldDefinitions)));
            oTr.append($(document.createElement("td")).append(oIsRequiredCheckbox));
            oTr.append($(document.createElement("td")).append(oIsNullCheckbox));
            oTr.append($(document.createElement("td")).append(createValuetype(index, valuetypes)));


            oTr.append($(document.createElement("td")).append(CreateCommonProperties(index, CommonPropertyNames)));



            oTr.append($(document.createElement("td")).append(oCustomPropertyNameTextBox));
            oTr.append($(document.createElement("td")).append(oValueTextBox).append(oButtonRemove));
            // Insert the row into the table
            $("#queryTable").append(oTr);
        };






        var bindEvents = function(e, gadgetContext) {
            $("input#addcriteria", this).bind("click", addcrit);
        };

        $(this).bind("epigadgetloaded", bindEvents);


    };

    function createcondition(index, fd) {
        var oSelect = $(document.createElement("select")).attr("name", "query[" + index + "].Condition").attr("id", "Condition" + index);

        $.each(fd, function(i, field) {
            oSelect.append($(document.createElement("option")).attr("value", field).html(field));
        });

        $(oSelect).children("option:first").attr("selected", "selected");


        return oSelect;
    }


    function createValuetype(index, vd) {
        var oSelect = $(document.createElement("select")).attr("name", "query[" + index + "].Type").attr("id", "Type" + index);

        $.each(vd, function(i, field) {
            oSelect.append($(document.createElement("option")).attr("value", field).html(field));
        });

        $(oSelect).children("option:first").attr("selected", "selected");


        return oSelect;


    }

    function CreateCommonProperties(index, cd) {

        var oSelect = $(document.createElement("select")).attr("name", "query[" + index + "].CommonPropertyName").attr("id", "CommmonPropertyName" + index);

        $.each(cd, function(i, field) {
            oSelect.append($(document.createElement("option")).attr("value", field).html(field));
        });

        $(oSelect).children("option:first").attr("selected", "selected");


        return oSelect;


    }


})(epiJQuery);


    