﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EPiServer;
using EPiServer.Core;

namespace FindPages.Models
{


    public static class CriteriaSetup
    {


        public static string[]  Conditions
        {
            get
            {
                
                var condtionnames = Enum.GetNames(typeof(EPiServer.Filters.CompareCondition));
                return condtionnames;
            }

        }

        public static string[] ValueTypes
        {
            get
            {
                var condtionnames = Enum.GetNames(typeof(EPiServer.Core.PropertyDataType));
                return condtionnames;
            }

        }



        

        public static string[] CommonPropertyNames
        {

            get
            {
                string[] propnames = {
                                        "PageName", "Changed", "ChangedBy", "Created", "CreatedBy", "IsDeleted", "IsModified", 
                                         "IsReadOnly", "LanguageBranch",  "PageTypeName", "PendingPublish", "Saved",
                                         "StartPublish", "StopPublish", "VisibleInMenu" };
                return propnames;                

            }
        }


        
    }
}
