<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl" %>
<%@ Import Namespace="EPiServer.Shell.Extensions" %>
<%@ Register Assembly="EPiServer.Shell" Namespace="EPiServer.Shell.Extensions" TagPrefix="aa"    %>

 
<script type="text/javascript">

    function removeRow(index) {
        // Delete the row
        
        $("#queryRow" + index).remove();
        // Search through the table and update all the remaining rows so that indices remain sequential
        $("tr[id^=queryRow]").each(function(i) {
            $(this).attr("id", "queryRow" + i);
            $("td input[id^=Required]", $(this)).attr("name", "query[" + i + "].Required").attr("id", "Required" + i);
            $("td input[id^=Name]", $(this)).attr("name", "query[" + i + "].Name").attr("id", "Name" + i).unbind("change").change(function() {

        });


        $("td input[id^=IsNull]", $(this)).attr("name", "query[" + i + "].IsNull").attr("id", "IsNull" + i).unbind("change").change(function() {

    });



    $("td select[id^=Condition]", $(this)).attr("name", "query[" + i + "].Condition").attr("id", "Condition" + i);
    $("td select[id^=CommonPropertyName]", $(this)).attr("name", "query[" + i + "].CommonPropertyName").attr("id", "CommonPropertyName" + i);
    $("td select[id^=Type]", $(this)).attr("name", "query[" + i + "].Type").attr("id", "Type" + i);
            
            
            $("td input[id^=Value]", $(this)).attr("name", "query[" + i + "].Value").attr("id", "Value" + i);
            $("td input[id^=Remove]", $(this)).attr("id", "Remove" + i).unbind("click").click(function() {
                removeRow(i);
            });
        });
    }

</script>

	<% Html.BeginGadgetForm("Search"); %>
	
	
      <table class="epi-default" id="queryTable" >
        <thead>
          <tr>
            <th>Condition</th>
            <th>Required</th>
            
            <th>IsNull</th>
            <th>Type</th>
            <th>Common property names</th>
            <th>Custom Propery name (will override dropdown)</th>
            
            <th>Value of Property</th>
            
          </tr>
          <tr>
          <td></td>
          
          </tr>
          
        </thead>
        <tbody>
        </tbody>
     
     </table>
 
   
      <input type="button" id="addcriteria" value="Add Criteria"  />    
      
      	<%= Html.AcceptButton("ha") %>
    <% Html.EndForm(); %>